#include<stdio.h>
#define diferenca 0.000001

/* Implementacao do algoritmo iterativo de Francois Viete (1540-1603) para
calculo de raizes quadradas.
        Explicando mais ou menos o metodo:
                Dado um numero N, "chutamos" a sua raiz R, essa raiz chutada
                difere da raiz real de E (erro). Assim temos que:

                        RaizQuadrada de N = sqrt(N) = R + E       (1)

                Quadrando os dois lados e desprezando E*E, que esperamos
                pequeno, obtemos:

                        N =~ R*R + 2*R*E                 (2)

                Isolando em E:

                        E =~ (N-R*R)/(2*R)               (3)

                Substituindo (3) em (1)

                        sqrt(N)=~ R+(N-R*R)/(2*R)       (4)

                Rearranjando:

                        sqrt(N)=~ (R+N/R)/2             (4)

		Podemo obter tambm uma expresso geral para clculo de
	raizes diferentes da quadrada.
		Para calcular a raiz cubica encontratiamos a expressao (2),
	com as potencias de E maiores do que dois eliminadas:
	cubica		N=~ 3*E*R^2+R^3

	prossegindo...	
	quarta		N=~ 4*E*R^3+R^4
	quinta		N=~ 5*E*R^4+R^5
	sexta		N=~ 6*E*R^5+R^6
	
	Concluimos que a expresso geral (2) e':
			N=~ W*E*R^(W-1)+R^W	
	Onde W e' o radicando.
	A expresso geral (4) e' ento:
			Wroot(N)=~ R + (N - R^W)/(W*R^(W-1)) = N/(W*R^(W-1)) + R(1 - 1/W)
	Deduzi mas nao verifiquei, cuidado!

	rymaeda@yahoo.com - members.xoom.com/rymaeda
*/


float Viete(float Numero){
float Raiz, Raiz_aux;

Raiz= 7; /* Chute inicial de 'Raiz': deve ser aproximadamente a media dos
            valores das raizes que voce pretende calcular, o que acarretara
            um menor numero de iteracoes e consequentemente maior rapidez
            ao programa, aqui utilizamos um numero arbitraio: 7 */
do{
        Raiz_aux=Raiz; /* Raiz_aux e' utilizada no criterio de parada */
        Raiz= (Raiz+Numero/Raiz)/2;
} while((Raiz>Raiz_aux?(Raiz-Raiz_aux):Raiz_aux-Raiz)>diferenca);
return(Raiz);
}

int main(){
        /* Alguns exemplos */
printf("%f 30 \n",Viete(30));
printf("%f 64 \n",Viete(64));
printf("%f 225\n",Viete(225));
printf("%f 846454\n",Viete(846454));
printf("%f 5433854\n",Viete(5433854));
}
